//	Tools Plus Tutorial -- Hello World!




 #include "ToolsPlus.h"



 #define ApplMenu	0						//Menu constants to make code more readable
 #define FileMenu	1
 #define EditMenu	2

 TPPollRecord		Poll;					//Polling record to retrieve event information
 Boolean				ExitTheDemo;	//Should the demo terminate?


 void ApplicationInitialization (void);
 void ProcessMenuSelection (void);
 void DrawWindowContents (void);






 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void main(void)
 {
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	MaxApplZone();


	if (!InitToolsPlus(1, 1, UseColor))
		ExitToShell();

	ApplicationInitialization();

	while (!ExitTheDemo)					//Main Event Loop
		{
		if (PollSystem(&Poll))			//If an event is available, process the event
			{
			switch (Poll.What)
				{
				case doMenu:
					ProcessMenuSelection();
					break;

				case doRefresh:		//Part of window needs to be refreshed
					BeginUpdate(WindowPointer(Poll.Window));	//Restrict drawing to area that needs it
					DrawWindowContents();
					EndUpdate(WindowPointer(Poll.Window));		//End the update for the window (unrestricted drawing)
					break;

				case doGoAway:			//User clicked a window's close box
					WindowClose(Poll.Window);
					break;

				case doButton: case doPictButton: case doKeyDown: case doAutoKey:
				case doClickField: case doScrollBar: case doListBox: case doPopUpMenu:
				case doClick:
					break;			//Other core events we're ignoring in this app

				default:
					break;			//All other events are ignored
			}
		}
		else
			{
				//	If your application has background processing, the code goes here and gets
				//	executed each time you call PollSystem and there are no events available.
			}
		}
 }



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void ApplicationInitialization (void)
	{
	//	Do all the application setup before you start polling for events

 	#define		DemoWindow1		1

	// Create an Apple menu with an 'About' item
	AppleMenu("\pAbout My App");

	// Create the standard File and Edit menus
	Menu(FileMenu, 0, enabled, "\pFile");
	Menu(FileMenu, 1, disabled, "\pNew/N");
	Menu(FileMenu, 2, disabled, "\pOpen/O");
	Menu(FileMenu, 3, disabled, "\pClose/W");
	Menu(FileMenu, 4, disabled, mDividingLine);
	Menu(FileMenu, 5, enabled, "\pQuit/Q");

	Menu(EditMenu, 0, enabled, "\pEdit");
	Menu(EditMenu, 1, disabled, "\pUndo/Z");
	Menu(EditMenu, 2, disabled, mDividingLine);
	Menu(EditMenu, 3, disabled, "\pCut/X");
	Menu(EditMenu, 4, disabled, "\pCopy/C");
	Menu(EditMenu, 5, disabled, "\pPaste/V");
	Menu(EditMenu, 6, disabled, "\pClear");
	Menu(EditMenu, 7, disabled, mDividingLine);
	Menu(EditMenu, 8, disabled, "\pShow Clipboard");
	UpdateMenuBar();

	WindowOpen(DemoWindow1, 5, 40, 425, 320, "\pHello World Tutorial", documentProc, GoAway, NotModal);
	DrawWindowContents();
	ExitTheDemo = false;
	}



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void DrawWindowContents (void)
	{
	//	Draw the contents of a window.  It's good to have this code in a separate
	//	routine because you need to use it [1] when a window is first opened, and
	//	[2] when a window needs to be refreshed.

	CurrentWindow(1);			//Subsequent drawing takes place on this window (current grafPort)
	TextFont(systemFont);
	TextSize(36);
	MoveTo(90, 140);
	DrawString("\pHello World!");
	}



 //	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-
 void ProcessMenuSelection (void)
	{
 	#define		NewItem		1
 	#define		OpenItem	2
 	#define		CloseItem	3
 	#define		QuitItem	5
 	
 	short			theButton;

	switch (Poll.Menu.Num)
		{
		case ApplMenu:	// Apple menu's 'About' item
			theButton = AlertBox(NoIcon, "\pThis is my applications about box.  (Click to close)", NoButtonAlert);
			break;
			
		case FileMenu:
			switch (Poll.Menu.Item)
				{
				case NewItem:
					break;
				case OpenItem:
					break;
				case CloseItem:
					break;
				case QuitItem:
					ExitTheDemo = true;
					break;
				}
		}

	MenuHilite(0);	// Turn off highlighted menu
	}