{	Tools Plus Tutorial	- -	Tools Bar and Floating Palettes	}

{	NOTE:	}
{	The MWERKS compiler directived ($IFC MWERKS) indicates code that is compiled only by	}
{	the CodeWarrior compiler.  THINK Pascal and Metrowerks CodeWarrior Pascal have	}
{	_slight_ differences, and this compiler directive lets you use one source for both compilers.	}
{	You can remove the code that does not pertain to your compiler.	}


program Tutorial;
	uses
{$IFC MWERKS}
		Dialogs, Fonts, Processes, SegLoad, TextEdit, ToolsPlus, Windows;
{$ELSEC}
		ToolsPlus;
{$ENDC}

	const
		FileMenu = 1;
		CloseItem = 1;
		QuitItem = 3;

	var
		Poll: TPPollRecord;			{Polling record to retrieve event information}
		ExitTheDemo: boolean;		{Should the demo terminate?}


{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
	procedure ApplicationInitialization;
		const
			StdWindow1 = 1;
			StdWindow2 = 2;
			ToolBar = 3;
			Palette1 = 4;
			Palette2 = 5;
			Palette3 = 6;

	begin
		AppleMenu('');
		Menu(FileMenu, 0, enabled, 'File');
		Menu(FileMenu, CloseItem, enabled, 'Close/W');
		Menu(FileMenu, 2, disabled, mDividingLine);
		Menu(FileMenu, QuitItem, enabled, 'Quit/Q');
		UpdateMenuBar;

		ToolBarOpen(ToolBar, 40, tbOffsetNewWindows);
		WindowOpen(StdWindow1, 0, 0, 230, 160, 'First Standard Window', noGrowDocProc + wTile, GoAway, NotModal);
		WindowOpen(StdWindow2, 0, 0, 230, 160, 'Second Standard Window', noGrowDocProc + wTile, GoAway, NotModal);

		WindowOpen(Palette1, 300, 35, 390, 190, 'Palette1', paletteProc, GoAway, NotModal);
		WindowOpen(Palette2, 320, 55, 410, 210, 'Palette2', paletteProc, GoAway, NotModal);
		WindowOpen(Palette3, 340, 75, 530, 130, '', altPaletteProc, GoAway, NotModal);

		ExitTheDemo := false;
	end;


{	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	-	}
begin
{$IFC MWERKS}
{Toolbox initialization - - Done automatically by THINK Pascal}
	InitGraf(@qd.thePort);
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(nil);
	MaxApplZone;
{$ENDC}

	if not InitToolsPlus(0, 6, UseColor) then
		ExitToShell;

	ApplicationInitialization;

	while not ExitTheDemo do	{Main Event Loop}
		if PollSystem(Poll) then	{If an event is available, process the event}

			case Poll.What of

				doMenu: 
					case Poll.Menu.Item of
						CloseItem:	{Close a window}
							begin
				{Close stanard wndows first, then palettes}
								if FirstStdWindowNumber <> none then
									WindowClose(FirstStdWindowNumber)
								else
									WindowClose(FirstWindowNumber);
								if FirstWindowNumber = none then	{If no windows open}
									EnableMenu(FileMenu, CloseItem, disabled);
								MenuHilite(0);
							end;

						QuitItem: 
							ExitTheDemo := true;
					end;

				doGoAway:	{A window's close box was clicked}
					begin
						WindowClose(Poll.Window);	{Close the clicked window}
						if FirstWindowNumber = none then	{If no windows are open}
							EnableMenu(FileMenu, CloseItem, disabled);
					end;

				doChgWindow:	{Activate the clicked window	}
					ActivateWindow(Poll.Window);

				otherwise	{All other events are ignored}
			end
end.